unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, ComCtrls,
  Buttons, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ImageList1: TImageList;
    Panel1: TPanel;
    Panel2: TPanel;
    ToolBar1: TToolBar;
    ToolButton0: TToolButton;
    ToolButton6: TToolButton;
    ToolButton10: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton5: TToolButton;
    ToolButton1: TToolButton;
    ToolButton9: TToolButton;
    ToolButton4: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure ToolBarButtonOrder(const AToolBar: TToolBar);
type
  TArr = Array of Integer;
  TBArr = Array of TToolButton;
  function NextWidth(const ABArr: TBArr; const AArr: TArr; const AIndex: Integer): Integer;
  var
    i: Integer;
  begin
    Result := 0;
    if (AIndex < 1) then
      Exit;
    for i := 0 to AIndex do
      if ABArr[i].Visible then
        Result += AArr[i];
  end;
var
  i: Integer;
  Arr: TArr;
  BArr: TBArr;
begin
  SetLength(Arr, AToolBar.ButtonCount);
  SetLength(BArr, AToolBar.ButtonCount);
  for i := 0 to Pred(AToolBar.ButtonCount) do
    begin
      BArr[AToolBar.Buttons[i].Tag] := AToolBar.Buttons[i];
      Arr[AToolBar.Buttons[i].Tag] := AToolBar.Buttons[i].Width;
    end;
  for i := Low(BArr) to High(BArr) do
    begin
      BArr[i].Align := alNone;
      BArr[i].Left := NextWidth(BArr, Arr, i);
    end;
end;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ToolButton9.Visible := False;
  ToolButton7.Visible := False;
  ToolButton8.Visible := False;
  ToolBarButtonOrder(ToolBar1);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  ToolButton9.Visible := True; // Trenner
  ToolButton7.Visible := True;
  ToolBarButtonOrder(ToolBar1);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ToolButton9.Visible := True; // Trenner
  ToolButton8.Visible := True;
  ToolBarButtonOrder(ToolBar1);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 ToolButton9.Visible := False; // Trenner
 ToolButton7.Visible := False;
 ToolButton8.Visible := False;
 ToolBarButtonOrder(ToolBar1);
end;


end.

